// ChessDataClient.java version 1.48, September 15, 2004.
// Copyright 1997-2004 by Rick Wagner, all rights reserved.
// This is a client for sending statistical information to a server. No use without attribution.

import java.io.*;                      // Input/output classes.
import java.net.*;                     // Network connection classes.
import java.util.*;                    // For Vector, bug fix Sep. 18, '02.

public class ChessDataClient2 extends Object
{
  protected Chess applet = null;
  
  private String appletposturl = null;
  private int iLineCounter = 0;
  private boolean bDirRx = false;
  private boolean savegamestatus = false;
  private String savegamestring = "";
  // Create a socket to communicate with a server
  public ChessDataClient2(Chess applet)                                       // Constructor
  {
	this.applet = applet;
	appletposturl = "http://chess.captain.at/chess/c.php";
//	appletposturl = "http://captain/chess/test/c.php";
  }
  
  public void reconnect()
  {
  }

  public void send(String str)
  {
 
	String line = new String();
	String inStr = new String();	
	URLConnection url;
	boolean debug = false;

	if (str.startsWith("0") || (savegamestatus == true) ) {
		savegamestatus = true;
		if (!str.startsWith("end")) {
			savegamestring = savegamestring + str + "|";
			return;
		} else {
			savegamestring = savegamestring + str;
			str = savegamestring;
			savegamestring = "";
			savegamestatus = false;
		}
	}
	
	try  {
		String fullUrl = new String(appletposturl);
		URL fileUrl = new URL(fullUrl);
		url = fileUrl.openConnection();
		url.setUseCaches(false);
		// Specify the content type.
		url.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
		//System.out.println("Content-Type: "+url.getRequestProperty("Content-Type"));
		url.setDoInput(true);
		url.setDoOutput(true);
	
		String outstreamstr = new String("data="+str);
	
		// Open the output stream
		PrintStream outStream = new PrintStream(url.getOutputStream());

		// Send the content
		outStream.println(outstreamstr);
		outStream.close();

		BufferedReader inFile = new BufferedReader( new InputStreamReader( url.getInputStream()));
		int i = 0;
		while ((inStr = inFile.readLine()) != null) {
			if (i == 0) { line = inStr; i++; }
			if (debug) System.out.println("output from script="+inStr);
		}
		int errint = -1;
		if (inStr != null) {
			errint = inStr.indexOf("ERR");
		}
		if (errint != -1) {
			System.out.println("err...");
		} 
		inFile.close();
	
	}	catch(MalformedURLException ex1)  {        System.out.println("URL not found...");	       }
                catch(java.security.AccessControlException e3){}
		catch(IOException ix1) {
			System.out.println("IOException:"+ix1);
			ix1.printStackTrace();
	}    
/////////////////////////////
    

	if (line == null)
	{
		System.out.println("Chess data server unexpectedly shut down.");
	} else {
		if (line.startsWith("0"))
		{
			// Got session ID.                                                      // New session.
			this.applet.sSessionID = new String(line);
			this.applet.btnOpen.enable();
			System.out.println("Session ID: " + this.applet.sSessionID + "\n");
			this.close();
		}
		else
		{
			if (line.startsWith("saved"))                                           // Saved game.
			{
				this.applet.btnReset.enable();
				this.applet.btnSave.enable();
				this.applet.lblMessage.setText("Saved game " + String.valueOf(Integer.parseInt(this.applet.sSessionID)) + ".");
				System.out.println("Saved game " + String.valueOf(Integer.parseInt(this.applet.sSessionID)) + ".\n");
				this.close();
			}
			else
			{
				if (line.startsWith("no"))                                            // Can't open game.
				{
					// Game not found.
					this.applet.btnReset.enable();
					this.applet.btnOpen.enable();
					this.applet.lblMessage.setText("Game " +
                                              String.valueOf(this.applet.iOpenGameNumber) +
                                              " not found.");
					this.close();
				}
				else
				{
					if (line.startsWith("dir") || bDirRx)                               // Receiving directory for open.
					{
						this.applet.lblMessage.setText("Receiving game list. Please wait.");
						this.applet.lGamesList.clear();  
						int i = 0;
						//String[] arr = line.split("\\|");
						String[] arr = splitit(line, '|');		  
						for (i = 0; i < arr.length; i++) {
							if (!arr[i].startsWith("dir") && !arr[i].startsWith("sent")) {
								this.applet.lGamesList.addItem(arr[i]);
							}
						}
						this.applet.lblMessage.setText("Sorting game list. Please wait.");
						this.applet.sortGames();
						this.applet.lGamesList.show();
						this.applet.lGamesList.addItem("Cancel", 0);
						this.applet.lblMessage.setText("Double-click the game file you wish to open.");  
						this.close();
					}
					else
					{
						// Opening a new game:                                             // Open game.
						if (line.startsWith("sgame")) {  
						int i = 0;
						String[] arr = splitit(line, '|');
						this.applet.taGameListing.setText("");
						this.applet.gnGameRoot.setBoard(arr[1]);
						this.applet.gnGameRoot.getBoard().refreshLegal();
						this.applet.sHumanFrom = null;
						for (i = 2; i < arr.length; i++) {
							if (!arr[i].startsWith("end")) {
								if (debug) System.out.println("load="+arr[i]);
								if ( i == (arr.length - 2) ) {						// bug#12 : last entry in game listing has no newline
									this.applet.taGameListing.appendText(arr[i]);  
								} else {
									this.applet.taGameListing.appendText(arr[i] + "\n");  
								}
							}
						}
						this.applet.iNumMoves = arr.length - 4;  // was - 2 ; now there are 2 lines more in the server response
						this.applet.btnReset.enable();
						this.applet.btnOpen.enable();
						this.applet.lblMessage.setText("Game " + String.valueOf(this.applet.iOpenGameNumber) + " opened.");
						System.out.println("Game " + String.valueOf(this.applet.iOpenGameNumber) + " opened.");
						this.applet.bThinking = false;
						this.applet.bGameOver = false;                                    // Bug fix Sep. 13, '02.
						this.applet.vHistory = new Vector();                              // Bug fix Sep. 18, '02.
						this.applet.vDuplicate = new Vector();                            // Bug fix Sep. 18, '02.
						this.applet.iRecursionLimit = this.applet.iParamRecurLimit;        // Reset the recursion limit (v. 1.45).
						this.applet.repaint();
						this.close();
					}
				}
			}
		}
	}
  }

    
////////////////////////////        
    
  } //end send

  public void listen()
  {
  }

  public void close()
  {
  }

  public void destroy()
  {
  //  close();
  }

	public String[] splitit(String s,char separator) {  
		int cnt=0,index;  
		String parsed[],tmp;  
		// Strip trailing separators... 
  		while(s.endsWith(separator+"")) {
			s=s.substring(0,s.length()-1);
		}  
		// Find number of words in string  
		for(int i=0; i<s.length(); i++) {
			if(s.charAt(i)==separator) cnt++;  
		}
		parsed=new String[cnt+1];  
		tmp=s;  
		for(int i=0; i<cnt+1; i++) {  
			index=tmp.indexOf(separator);  
			if(index!=-1) {
				parsed[i]=tmp.substring(0,index);  
				tmp=tmp.substring(index+1);  
			} else {
				parsed[i]=tmp;  
			}
		}  
		return parsed;  
	}
	
	
} // End class ChessDataClient



