// ChessMemoryClient.java version 1.15, January 29, 2004.
// Copyright 1997-2004 by Rick Wagner, all rights reserved.
// This is a client for sending statistical information to a server. No use without attribution.

import java.io.*;                      // Input/output classes.
import java.net.*;                     // Network connection classes.

public class ChessMemoryClient2 extends Object
{
  protected Chess applet = null;
  private String appletposturl = null;
  
  // Create a socket to communicate with a server
  public ChessMemoryClient2(Chess applet)                                       // Constructor
  {
  this.applet = applet;
  appletposturl = "http://chess.captain.at/chess/c.php";
//  appletposturl = "http://captain/chess/test/c.php";
  }
  
  public void reconnect()
  {
  }

  public void send(String str)
  {
  String line = new String();
  String inStr = new String();
  URLConnection url;
  boolean debug = false;
  
  str = str + "-r1-"+this.applet.iRecursionLimit+"-r2-"+this.applet.iParamRecurLimit;

  try  {
    String fullUrl = new String(appletposturl);
    URL fileUrl = new URL(fullUrl);
    url = fileUrl.openConnection();
    url.setUseCaches(false);
    // Specify the content type.
    url.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
    //System.out.println("Content-Type: "+url.getRequestProperty("Content-Type"));
    url.setDoInput(true);
    url.setDoOutput(true);
  
    String outstreamstr = new String("data="+str);
  
    // Open the output stream
    PrintStream outStream = new PrintStream(url.getOutputStream());

    // Send the content
    outStream.println(outstreamstr);
    outStream.close();

    BufferedReader inFile = new BufferedReader( new InputStreamReader( url.getInputStream()));
    int i = 0;
    while ((inStr = inFile.readLine()) != null) {
      if (i == 0) { line = inStr; i++; }
      if (debug) System.out.println("output from script="+inStr);
    }
    int errint = -1;
    if (inStr != null) {
      errint = inStr.indexOf("ERR");
    }
    if (errint != -1) {
      System.out.println("err...");
    } 
    inFile.close();
  
  }  catch(MalformedURLException ex1)  {        System.out.println("URL not found...");         }
    catch(IOException ix1) {
      System.out.println("IOException:"+ix1);
      ix1.printStackTrace();
  }  
  
  if (line == null)
  {
    System.out.println("Chess data server unexpectedly shut down during memory listening.");
  }
  else
  {
    if (line.startsWith("found "))
    {
      // The server found our move.
      this.applet.sMoveFromServer = line.substring(6);
      if (this.applet.bVerbose)
      {
        System.out.println("Server has the move.");
      }
    }
    else
    {
      if (line.startsWith("not found"))
      {
        // The server could not find our move.
        this.applet.sMoveFromServer = "not found";
        if (this.applet.bVerbose)
        {
          System.out.println("Server does not have the move.");
        }
      }
      else
      {
        if (line.startsWith("echo "))
        {
          // Echo strings from the server:
          if (this.applet.bVerbose)
          {
            System.out.println(line.substring(5));
          }
        }
        else
        {
          System.out.println("Unrecognized string from chess data server in chess memory client.");
        }
      }
    }
  }
  
  }

  public void listen()
  {
  }

  public void close()
  {
  }

  public void destroy()
  {
    //close();
  }
} // End class ChessMemoryClient

