// RememberedPosition.java version 1.01, July 22, 2002. Copyright by Rick Wagner,
// all rights reserved.

// A class for memory so the applet can learn as it plays:

public class RememberedPosition
{
  private String sChessBoard = null;                               // The piece configuration.
  private String sBestNextBoard = null;                            // The configuration representing the best move.
  private int iEvalDepth = 0;                                      // How deep did it go to find the best move?

  public RememberedPosition()                                      // Default constructor.
  {
    sChessBoard = null;
    sBestNextBoard = null;
    iEvalDepth = 0;
  }

  public RememberedPosition(RememberedPosition rp)                 // Copy constructor.
  {
    sChessBoard = new String(rp.sChessBoard);
    sBestNextBoard = new String(rp.sBestNextBoard);
    iEvalDepth = rp.iEvalDepth;
  }

  public RememberedPosition(String s)                              // String constructor.
  {
    String sEvalDepth = null;

    sChessBoard = s.substring(0, 65);
    sEvalDepth = s.substring(65, 67);
    sBestNextBoard = s.substring(67);
    try
    {
      iEvalDepth = Integer.parseInt(sEvalDepth);
    }
    catch (NumberFormatException e)
    {
      iEvalDepth = 0;
    }
  }

  public RememberedPosition(String sCurrent, String sBest, int iDepth)  // General constructor
  {
    sChessBoard = new String(sCurrent);
    sBestNextBoard = new String(sBest);
    iEvalDepth = iDepth;
  }

  public int getEvalDepth()
  {
    return iEvalDepth;
  }

  public String getBest()
  {
    return sBestNextBoard;
  }

  public String getBoard()
  {
    return sChessBoard;
  }

  public String toString()
  {
    String sR = null;
    String sEvalDepth = null;

    sEvalDepth = String.valueOf(iEvalDepth);
    sEvalDepth = "0" + sEvalDepth;
    sEvalDepth = sEvalDepth.substring(sEvalDepth.length() - 2);

    sR = sChessBoard + sEvalDepth + sBestNextBoard;

    return sR;
  }
}

